<?php

namespace App\DataTables;

use Carbon\Carbon;
use App\Models\StudentNote;
use Yajra\DataTables\Html\Button;
use Yajra\DataTables\Html\Column;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Auth;
use Yajra\DataTables\Html\Editor\Editor;
use Yajra\DataTables\Html\Editor\Fields;
use Yajra\DataTables\Services\DataTable;

class NotesDataTable extends DataTable
{
    /**
     * Build DataTable class.
     *
     * @param mixed $query Results from query() method.
     * @return \Yajra\DataTables\DataTableAbstract
     */
    public function dataTable($query)
    {
        return datatables()
            ->eloquent($query)
            ->addColumn('Action', 'admin.notes.action')
            ->rawColumns([
                'Action',
            ])
            ->setRowId(function ($record) {
                return 'row_' . $record->id;
            })
            ->editColumn('created_at', function ($record) {
                return $record->created_at ? with(new Carbon($record->created_at))->format('Y-m-d H:i') : '';
            })
            ->editColumn('type', function ($record) {
                return trans('general.' . $record->type);
            })
            ->filterColumn('type', function ($query, $keyword) {
                $keywords = trim($keyword);
                $query->whereRaw("student_notes_types.code like ?", ["%{$keywords}%"]);
            })
            ->filterColumn('student', function ($query, $keyword) {
                $keywords = trim($keyword);
                $query->whereRaw("CONCAT(students.first_name, ' ',students.last_name) like ?", ["%{$keywords}%"]);
            })
            ->addIndexColumn();
    }



    public function lang()
    {

        $langJson = [
            "sEmptyTable"     =>  trans('general.datatable.sEmptyTable'),
            "sInfo"           =>  trans('general.datatable.sInfo'),
            "sInfoEmpty"      =>  trans('general.datatable.sInfoEmpty'),
            "sInfoFiltered"   =>  trans('general.datatable.sInfoFiltered'),
            "sInfoPostFix"    =>  trans('general.datatable.sInfoPostFix'),
            "sInfoThousands"  =>  trans('general.datatable.sInfoThousands'),
            "sLengthMenu"     =>  trans('general.datatable.sLengthMenu'),
            "sLoadingRecords" =>  trans('general.datatable.sLoadingRecords'),
            "sProcessing"     =>  trans('general.datatable.sProcessing'),
            "sSearch"         =>  trans('general.datatable.sSearch'),
            "sZeroRecords"    =>  trans('general.datatable.sZeroRecords'),
            "sFirst"          =>  trans('general.datatable.sFirst'),
            "sLast"           =>  trans('general.datatable.sLast'),
            "sNext"           =>  trans('general.datatable.sNext'),
            "sPrevious"       =>  trans('general.datatable.sPrevious'),
            "sSortAscending"  =>  trans('general.datatable.sSortAscending'),
            "sSortDescending" =>  trans('general.datatable.sSortDescending'),
            "paginate"=> [
                "first"=> trans('general.datatable.sFirst'),
                "previous"=> trans('general.datatable.sPrevious'),
                "next"=> trans('general.datatable.sNext'),
                "last"=> trans('general.datatable.sLast')
            ],
        ];
        return $langJson;
    }

    /**
     * Get query source of dataTable.
     *
     * @param \App\Models\StudentNote $model
     * @return \Illuminate\Database\Eloquent\Builder
     */
    public function query(StudentNote $model)
    {
        // return $model->newQuery();

        $allowedDivisions = [];
        $userPermission = Auth::guard('admin')->user()->getUserPermissionByCode('manage-notes');
        if ($userPermission) {
            $allowedDivisions = json_decode($userPermission['details'], true)['divisions'];
        }

        if (in_array(-1, $allowedDivisions)) {
            return $model->select('student_notes.*', 'student_notes_types.code as type', DB::raw("CONCAT(students.first_name, ' ',students.last_name) AS student"),)
                ->join('student_notes_types', 'student_notes_types.id', '=', 'student_notes.type_id')
                ->join('students', 'students.id', '=', 'student_notes.student_id')
                ->orderBy('id', 'desc');
        } else {
            return $model->select('student_notes.*', 'student_notes_types.code as type', DB::raw("CONCAT(students.first_name, ' ',students.last_name) AS student"),)
                ->join('student_notes_types', 'student_notes_types.id', '=', 'student_notes.type_id')
                ->join('students', 'students.id', '=', 'student_notes.student_id')
                ->whereIn('students.division_id', $allowedDivisions)
                ->orderBy('id', 'desc');
        }
    }

    /**
     * Optional method if you want to use html builder.
     *
     * @return \Yajra\DataTables\Html\Builder
     */
    public function html()
    {
        return $this->builder()
            ->setTableId('notes-table')
            ->columns($this->getColumns())
            ->minifiedAjax()
            ->dom('<"d-flex justify-content-between align-items-center mx-0 row"<"col-sm-12 col-md-6"l><"col-sm-12 col-md-6"f>>t<"d-flex justify-content-between mx-0 row"<"col-sm-12 col-md-6"i><"col-sm-12 col-md-6"p>>')
            ->orderBy(0)
            ->buttons(
                Button::make('reset')->text(' <i class="fas fa-redo"></i> ' . trans('app.datatable.reset')),
                Button::make('reload')->text(' <i class="fas fa-sync-alt"></i> ' . trans('app.datatable.reload')),
            )->parameters([
                'responsive' => true,
                'autoWidth' => false,
                'lengthMenu' => [[10, 25, 50, 100], ['10', '25', '50', '100']],
                'language' => $this->lang(),
            ]);
    }

    /**
     * Get columns.
     *
     * @return array
     */
    protected function getColumns()
    {
        return [
            Column::computed('DT_RowIndex')->title('#')
                ->addClass('text-center'),
            Column::make('student')->title(trans('general.student')),
            Column::make('type')->title(trans('general.type')),
            Column::make('text')->title(trans('general.text')),
            Column::make('created_at')->title(trans('general.created-at')),
            Column::computed('Action')->title(trans('general.options'))
                ->exportable(false)
                ->printable(false)
                ->addClass('text-center')
                ->searchable(false),
        ];  
    }

    /**
     * Get filename for export.
     *
     * @return string
     */
    protected function filename()
    {
        return 'StudentNotes_' . date('YmdHis');
    }
}
